unit RecieveVipNumber;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Memo1: TMemo;
    procedure WndProc(var Message: TMessage); override; //   
    procedure FormCreate(Sender: TObject);
    function UnpackPhoneNumber(W1, W2: LongWord; var Incoming: boolean): string;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  wm_VipNumberReceived: Int64; //     

implementation

{$R *.dfm}
  procedure TForm1.FormCreate(Sender: TObject);
  begin
    wm_VipNumberReceived := RegisterWindowMessage('wm_VipNumberReceived'); //    wm_VipNumberReceived
  end;

  function ByteToChar(B: byte): char;
  begin
    case B of
      $0A: Result := '-';
      $0C: Result := 'P';
      $0D: Result := '_';
      $0E: Result := 't';
      $0F: Result := '';
      0..9: Result := Chr(B + $30);
    end;
  end;

  function TForm1.UnpackPhoneNumber(W1, W2: LongWord; var Incoming: boolean): string;
  var
    I: integer;
    ChArr: array[1..8] of char;
  begin
    Result := '';
    I := 1;
    Move(W1, ChArr[1], 4);
    Move(W2, ChArr[5], 4);
    Incoming := Ord(ChArr[8]) = 0; // ,   
    while (I < 8) do begin
      if (Ord(ChArr[I]) and $0F) <> $0B then begin
        Result := Result + ByteToChar(Ord(ChArr[I]) and $0F);
        if (Ord(ChArr[I]) and $F0) <> $B0 then
          Result := Result + ByteToChar((Ord(ChArr[I]) and $F0) shr 4)
        else Exit;
      end else Exit;
      Inc(I);
    end;
  end;

  procedure TForm1.WndProc(var Message: TMessage);
  var
    PhoneNumber, S: string;
    Incoming: boolean;
  begin
    if Message.Msg = wm_VipNumberReceived then begin
      PhoneNumber := UnpackPhoneNumber(Message.wParam, Message.lParam, Incoming);
      if Incoming then S := ' : ' else S := ' : ';
      Memo1.Text := Memo1.Text + #13#10 + S + PhoneNumber;
    end;
    inherited;
  end;
end.
